wxRuby Documentation Home

# Wx::Frame

A frame is a window whose size and position can (usually) be changed by the
user. It usually has thick borders and a title bar, and can optionally contain
a menu bar, toolbar and status bar. A frame can contain any window that is not
a frame or dialog.

A frame that has a status bar and toolbar created via the
CreateStatusBar/CreateToolBar functions manages these windows, and adjusts the
value returned by GetClientSize to reflect the remaining size available to
application windows.

## Derived from

TopLevelWindow

Window

EvtHandler

Object

## Window styles

`DEFAULT_FRAME_STYLE` | Defined as `MINIMIZE_BOX`|`MAXIMIZE_BOX`|`RESIZE_BORDER`| `SYSTEM_MENU`|`CAPTION`|`CLOSE_BOX`|`CLIP_CHILDREN`
`ICONIZE` | Display the frame iconized (minimized). Windows only.
`CAPTION` | Puts a caption on the frame.
`MINIMIZE` | Identical to ICONIZE. Windows only.
`MINIMIZE_BOX` | Displays a minimize box on the frame.
`MAXIMIZE` | Displays the frame maximized. Windows only.
`MAXIMIZE_BOX` | Displays a maximize box on the frame.
`CLOSE_BOX` | Displays a close box on the frame.
`STAY_ON_TOP` | Stay on top of all other windows, see also `FRAME_FLOAT_ON_PARENT`.
`SYSTEM_MENU` | Displays a system menu.
`RESIZE_BORDER` | Displays a resizeable border around the window.
`FRAME_TOOL_WINDOW` | Causes a frame with a small titlebar to be created; the frame does not appear in the taskbar under Windows or GTK+.

`FRAME_NO_TASKBAR`

Creates an otherwise normal frame but it does not
appear in the taskbar under Windows or GTK+ (note that it will minimize
to the desktop window under Windows which may seem strange to the users
and thus it might be better to use this style only without `MINIMIZE_BOX`
style). In GTK, the flag is respected only if GTK+ is at least version
2.2. Has no effect under other platforms.

`FRAME_FLOAT_ON_PARENT` | The frame will always beon top of its parent (unlike STAY_ON_TOP). A frame created with this stylemust have a non-NULL parent.
`FRAME_EX_CONTEXTHELP` | Under Windows, puts a query button on the caption. When pressed, Windows will go into a context-sensitive help mode and Widgets will senda EVT_HELP event if the user clicked on an application window. Note that this is not currently supported in wxRuby
`FRAME_SHAPED` | Windows with this style are allowed to have their shape changed with the set_shape method.
`FRAME_EX_METAL` | On Mac OS X, frames with this style will be shown with a metallic look. This is an extra style.

The default frame style is for normal, resizeable frames. To create a frame
which can not be resized by user, you may use the following combination of
styles:

`DEFAULT_FRAME_STYLE` & ~ (`RESIZE_BORDER`|`RESIZE_BOX`|`MAXIMIZE_BOX`).

See also window styles overview.

## Default event processing

The following event handlers are available for Frame:

evt_size() { | event | … } | If the frame has exactly one child window, not counting the status and toolbar, this child is resized to take the entire frame client area. If two or more windows are present, they should be laid out explicitly either by manually handling the SizeEvent from this handler, or, preferably, using sizers
evt_menu_highlight() { | event | … } | The default implementation displays the help string associated with the selected item in the first pane of the status bar, if there is one. The MenuEvent may be manually handled if preferred

## Remarks

An application should normally define an CloseEvent handler for the
frame to respond to system close events, for example so that related data and subwindows can be cleaned up.

## See also

MDIParentFrame, MDIChildFrame, MiniFrame, Dialog

## Methods

- Frame.new
- Frame#centre
- Frame#create
- Frame#create_status_bar
- Frame#create_tool_bar
- Frame#get_client_area_origin
- Frame#get_menu_bar
- Frame#get_status_bar
- Frame#get_status_bar_pane
- Frame#get_tool_bar
- Frame#on_create_status_bar
- Frame#on_create_tool_bar
- Frame#process_command
- Frame#send_size_event
- Frame#set_menu_bar
- Frame#set_status_bar
- Frame#set_status_bar_pane
- Frame#set_status_text
- Frame#set_status_widths
- Frame#set_tool_bar

### Frame.new

Frame.new(%(arg-type)Window% parent, Integer id, String title, Point pos = DEFAULT_POSITION, Size size = DEFAULT_SIZE, Integer style = DEFAULT_FRAME_STYLE, String name = “frame”)

Constructor, creating the window.

#### Parameters

- parent The window parent. This may be NULL. If it is non-NULL, the frame will
  always be displayed on top of the parent window on Windows.
- id The window identifier. It may take a value of -1 to indicate a default value.
- title The caption to be displayed on the frame’s title bar.
- pos The window position. A value of (-1, -1) indicates a default position, chosen by
  either the windowing system or Widgets, depending on platform.
- size The window size. A value of (-1, -1) indicates a default size, chosen by
  either the windowing system or Widgets, depending on platform.
- style The window style. See Frame.
- name The name of the window. This parameter is used to associate a name with the item,
  allowing the application user to set Motif resource values for
  individual windows.

#### Remarks

For Motif, MWM (the Motif Window Manager) should be running for any window styles to work
(otherwise all styles take effect).

#### See also

Frame#create

### Frame#centre

centre(%(arg-type)Integer% direction = BOTH)

Centres the frame on the display.

#### Parameters

- direction The parameter may be `HORIZONTAL`, `VERTICAL` or `BOTH`.

### Frame#create

Boolean create(%(arg-type)Window% parent, Integer id, String title, Point pos = DEFAULT_POSITION, Size size = DEFAULT_SIZE, Integer style = DEFAULT_FRAME_STYLE, String name = “frame”)

Used in two-step frame construction. See Frame.new for further details.

### Frame#create_status_bar

StatusBar create_status_bar(%(arg-type)Integer% number = 1, Integer style = 0, Integer id = -1, String name = “statusBar”)

Creates a status bar at the bottom of the frame.

#### Parameters

- number The number of fields to create. Specify a
  value greater than 1 to create a multi-field status bar.
- style The status bar style. See StatusBar for a list
  of valid styles.
- id The status bar window identifier. If -1, an identifier will be chosen by
  Widgets.
- name The status bar window name.

#### Return value

A pointer to the status bar if it was created successfully, NULL otherwise.

#### Remarks

The width of the status bar is the whole width of the frame (adjusted automatically when
resizing), and the height and text size are chosen by the host windowing system.

By default, the status bar is an instance of StatusBar. To use a different class,
override Frame#on_create_status_bar.

Note that you can put controls and other windows on the status bar if you wish.

#### See also

Frame#set_status_text, Frame#on_create_status_bar, Frame#get_status_bar

### Frame#create_tool_bar

ToolBar create_tool_bar(%(arg-type)Integer% style = NO_BORDER TB_HORIZONTAL, Integer id = -1, String name = “toolBar”)

Creates a toolbar at the top or left of the frame.

#### Parameters

- style The toolbar style. See ToolBar for a list
  of valid styles.
- id The toolbar window identifier. If -1, an identifier will be chosen by
  Widgets.
- name The toolbar window name.

#### Return value

A pointer to the toolbar if it was created successfully, NULL otherwise.

#### Remarks

By default, the toolbar is an instance of ToolBar (which is defined to be
a suitable toolbar class on each platform, such as ToolBar95). To use a different class,
override Frame#on_create_tool_bar.

When a toolbar has been created with this function, or made known to the frame
with Frame#set_tool_bar, the frame will manage the toolbar
position and adjust the return value from Window#get_client_size to
reflect the available space for application windows.

Under Pocket PC, you should always use this function for creating the toolbar
to be managed by the frame, so that Widgets can use a combined
menubar and toolbar. Where you manage your own toolbars, create a ToolBar
as usual.

#### See also

Frame#create_status_bar, Frame#on_create_tool_bar, Frame#set_tool_bar, Frame#get_tool_bar

### Frame#get_client_area_origin

Point get_client_area_origin()

Returns the origin of the frame client area (in client coordinates). It may be
different from (0, 0) if the frame has a toolbar.

### Frame#get_menu_bar

MenuBar get_menu_bar()

Returns a pointer to the menubar currently associated with the frame (if any).

#### See also

Frame#set_menu_bar, MenuBar, Menu

### Frame#get_status_bar

StatusBar get_status_bar()

Returns a pointer to the status bar currently associated with the frame (if any).

#### See also

Frame#create_status_bar, StatusBar

### Frame#get_status_bar_pane

Integer get_status_bar_pane()

Returns the status bar pane used to display menu and toolbar help.

#### See also

Frame#set_status_bar_pane

### Frame#get_tool_bar

ToolBar get_tool_bar()

Returns a pointer to the toolbar currently associated with the frame (if any).

#### See also

Frame#create_tool_bar, ToolBar, Frame#set_tool_bar

### Frame#on_create_status_bar

StatusBar on_create_status_bar(%(arg-type)Integer% number, Integer style, Integer id, String name)

Virtual function called when a status bar is requested by Frame#create_status_bar.

#### Parameters

- number The number of fields to create.
- style The window style. See StatusBar for a list
  of valid styles.
- id The window identifier. If -1, an identifier will be chosen by
  Widgets.
- name The window name.

#### Return value

A status bar object.

#### Remarks

An application can override this function to return a different kind of status bar. The default
implementation returns an instance of StatusBar.

#### See also

Frame#create_status_bar, StatusBar.

### Frame#on_create_tool_bar

ToolBar on_create_tool_bar(%(arg-type)Integer% style, Integer id, String name)

Virtual function called when a toolbar is requested by Frame#create_tool_bar.

#### Parameters

- style The toolbar style. See ToolBar for a list
  of valid styles.
- id The toolbar window identifier. If -1, an identifier will be chosen by
  Widgets.
- name The toolbar window name.

#### Return value

A toolbar object.

#### Remarks

An application can override this function to return a different kind of toolbar. The default
implementation returns an instance of ToolBar.

#### See also

Frame#create_tool_bar, ToolBar.

### Frame#process_command

process_command(%(arg-type)Integer% id)

Simulate a menu command.

#### Parameters

- id The identifier for a menu item.

### Frame#send_size_event

send_size_event()

This function sends a dummy size event to the frame
forcing it to reevaluate its children positions. It is sometimes useful to call
this function after adding or deleting a children after the frame creation or
if a child size changes.

Note that if the frame is using either sizers or constraints for the children
layout, it is enough to call Layout directly and
this function should not be used in this case.

### Frame#set_menu_bar

set_menu_bar(%(arg-type)MenuBar% menuBar)

Tells the frame to show the given menu bar.

#### Parameters

- menuBar The menu bar to associate with the frame.

#### Remarks

If the frame is destroyed, the
menu bar and its menus will be destroyed also, so do not delete the menu
bar explicitly (except by resetting the frame’s menu bar to another
frame or NULL).

Under Windows, a size event is generated, so be sure to initialize
data members properly before calling SetMenuBar.

Note that on some platforms, it is not possible to call this function twice for the same frame object.

#### See also

Frame#get_menu_bar, MenuBar, Menu.

### Frame#set_status_bar

set_status_bar(%(arg-type)StatusBar% statusBar)

Associates a status bar with the frame.

#### See also

Frame#create_status_bar, StatusBar, Frame#get_status_bar

### Frame#set_status_bar_pane

set_status_bar_pane(%(arg-type)Integer% n)

Set the status bar pane used to display menu and toolbar help.
Using -1 disables help display.

### Frame#set_status_text

set_status_text(%(arg-type)String% text, Integer number = 0)

Sets the status bar text and redraws the status bar.

#### Parameters

- text The text for the status field.
- number The status field (starting from zero).

#### Remarks

Use an empty string to clear the status bar.

#### See also

Frame#create_status_bar, StatusBar

### Frame#set_status_widths

set_status_widths(%(arg-type)Array% widths)

Sets the widths of the fields in the status bar. This should be an array
of integers corresponding to the desired pixel widths of each field. The
array should therefore be have the same length as the number of fields
set up by a previous call to set_status_bar.

As an alternative to specifying a fixed pixel width for a field, the
value -1 can be used to request a variable-width field. The widths of
the variable fields are calculated from the total width of all fields,
minus the sum of widths of the non-variable fields, divided by the
number of variable fields.

### Frame#set_tool_bar

set_tool_bar(%(arg-type)ToolBar% toolBar)

Associates a toolbar with the frame.

#### See also

Frame#create_tool_bar, ToolBar, Frame#get_tool_bar

[This page automatically generated from the Textile source at 2023-06-09 00:45:30 +0000]